.git_config: &git_config |
  set -x
  # set git credentials
  git config --global user.name "Linaro Gitlab oe-rpb-manifest-poll CI"
  git config --global user.email "ci_notify@linaro.org"

.repo_manifest_sync: &repo_manifest_sync |
  # docker image just have python3, so we need to indicate
  # repo to use it instead of python at shebang line
  sed -i '1s/python/python3/' $(which repo)

  diffmanifests=''
  # no need to repo init & sync in case force trigger
  if [ "$FORCE_TRIGGER" == "false" ]; then
    if [ ! -d $REPO_DIR ]; then
      mkdir -p $REPO_DIR && pushd $REPO_DIR
      repo init -u $MANIFEST_URL -b $MANIFEST_BRANCH
      repo sync --verbose
      repo manifest --revision-as-HEAD > manifest_last_sync.xml
      touch $REPO_DIFFMANIFESTS
      FORCE_TRIGGER='true' # first time, force trigger
      popd
    else
      pushd $REPO_DIR

      # useful debug log before sync
      (repo --version; repo info | tee $REPO_INFO; cd .repo/repo; git status; git diff)

      repo sync --verbose
      repo manifest --revision-as-HEAD > manifest_now_sync.xml
      diffmanifests=$(repo diffmanifests manifest_last_sync.xml manifest_now_sync.xml)
      popd
    fi

    (cd $REPO_DIR; repo info > $REPO_INFO)

    # check if there are manifest differences
    if [ -n "$diffmanifests" ];  then
      pushd $REPO_DIR
      mv manifest_now_sync.xml manifest_last_sync.xml
      echo "$diffmanifests" > $REPO_DIFFMANIFESTS
      popd
    fi
  fi

.trigger_if_manifest_changes: &trigger_if_manifest_changes |
  if [ -n "$diffmanifests" -o "$FORCE_TRIGGER" == "true" ]; then
    for project_path in $PROJECT_PATHS
    do
      project_id="${project_path//\//%2F}"
      case "$project_path" in

        $OE_PROJECT_PATH | $GITLAB_OE_PROJECT_PATH)

          # gitlab-oe project defines MANIFEST_BRANCH_PREFIX and MANIFEST_BRANCH variables
          # whether the oe project MANIFEST_BRANCH contains both in its value, so trim the
          # qcom/ MANIFEST_BRANCH prefix for gitlab-oe
          test "$project_path" = "$GITLAB_OE_PROJECT_PATH" && MANIFEST_BRANCH="${MANIFEST_BRANCH#qcom/}"

          curl --fail --request POST --form token=$CI_JOB_TOKEN --form ref=master \
            -F "variables[MANIFEST_BRANCH]=\"$MANIFEST_BRANCH\"" \
            -F "variables[MANIFEST_URL]=\"$MANIFEST_URL\"" \
            -F "variables[IMAGES]=\"$IMAGES\"" \
            -F "variables[IMAGES_RPB]=\"$IMAGES_RPB\"" \
            -F "variables[IMAGES_RPB_WAYLAND]=\"$IMAGES_RPB_WAYLAND\"" \
            -F "variables[BUILD_SDK]=\"$BUILD_SDK\"" \
            -F "variables[JFROG_UPLOAD_DRY_RUN]=\"$JFROG_UPLOAD_DRY_RUN\"" \
            "${CI_API_V4_URL}/projects/${project_id}/trigger/pipeline"
          ;;

        $LINUX_TESTIMAGES_PROJECT_PATH)
          curl --fail --request POST --form token=$CI_JOB_TOKEN --form ref=master \
            -F "variables[JFROG_UPLOAD_DRY_RUN]=\"$JFROG_UPLOAD_DRY_RUN\"" \
            "${CI_API_V4_URL}/projects/${project_id}/trigger/pipeline"
          ;;

        $MOCK_PROJECT_PATH)
          curl --fail --request POST --form token=$CI_JOB_TOKEN --form ref=master \
            "${CI_API_V4_URL}/projects/${project_id}/trigger/pipeline"
          ;;

        *)
          echo "Project $project_path not triggered"
          ;;
      esac
    done
  fi

.poll:
  stage: polling
  script:
    - *git_config
    - *repo_manifest_sync
    - *trigger_if_manifest_changes
